require("autobatch")
require "gooi"
ball8 = {}
state = 1
counting = 0
alphaUi = 0
pergunta = ""


threadCount = 8
threadList = {}
messages = {}
returns = 0

function love.load()
	--Função que cria a UI e carrega os gráficos
	ball8.image = love.graphics.newImage("8ball.png")
	ball8.x = 140
	ball8.y = 160

	taboo = love.audio.newSource("taboo.mp3")
	pop = love.audio.newSource("pop.mp3")
	pop:setVolume(1)
	love.graphics.setBackgroundColor(22, 22, 22)
	font = love.graphics.newFont(18)
	font2 = love.graphics.newFont(36)

	--Específicos: GooI =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==
	style = {font = love.graphics.newFont(36),showBorder = true}
	gooi.setStyle(style)
	upB = gooi.newButton({text = "+", x = 420, y = 280, w = 64, h = 64}):onRelease(function() threadCount = threadCount + 1 end)
	upB:bg({55, 55, 55})
	upB:setVisible(false)
	downB = gooi.newButton({text = "-", x = 420, y = 410, w = 64, h = 64}):onRelease(function() threadCount = threadCount - 1 end)
	downB:bg({55, 55, 55})
	downB:setVisible(false)
	perguntaLabel = gooi.newLabel({text = "Pergunte: ", x = 80, y = 220})
	perguntaLabel:setVisible(false)
	style2 = {font = love.graphics.newFont(16),showBorder = true}
	gooi.setStyle(style2)
	counterLabel = gooi.newLabel({text = threadCount, x = 470, y = 360})
	counterLabel:setVisible(false)
	vaiB = gooi.newButton({text = "Vai!", x = 220, y = 460}):onRelease(function() state = 2 end)
	vaiB:setVisible(false)
	textField = gooi.newText({x = 40, y = 310, w = 300, h = 125})
	textField:setVisible(false)
	topL = gooi.newLabel({text = "Threads?", x = 437, y = 240})
	topL:setVisible(false)
	--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==

	--Cria o canal de comunicação com as threads filhas.
	channel = love.thread.getChannel("call")
end


function love.update(dt)
	if threadCount < 1 then threadCount = 1 end

	--Maquina de estados: Estado 1 // Menu principal
	if state == 1 then
		counting = counting + dt
		if counting >= 1.5 then
			ball8.y = lerp(ball8.y, 40, 0.007)
			alphaUi = lerp(alphaUi, 255, 0.017)
			if alphaUi >= 250 then
				if taboo:isPlaying() ~= true then
					taboo:play()
					taboo:setVolume(0.7)
				end
				upB:setVisible(true)
				downB:setVisible(true)
				topL:setVisible(true)
				counterLabel:setText(threadCount)
				counterLabel:setVisible(true)
				perguntaLabel:setVisible(true)
				vaiB:setVisible(true)
				textField:setVisible(true)
			end
		end
	end

	--Maquina de estados: Estado 2 // Inicia as threads
	if state == 2 then
		upB:setVisible(false)
		downB:setVisible(false)
		topL:setVisible(false)
		counterLabel:setText("")
		counterLabel:setVisible(false)
		perguntaLabel:setVisible(false)
		vaiB:setVisible(false)
		textField:setVisible(false)

		--Cria e inicia as threads.
		for i=1,threadCount do
			threadList[i] = love.thread.newThread("threadCode.lua")
			threadList[i]:start()
		end
		table.insert(messages, "Criadas "..threadCount.." threads!")

		--Altera para o estado de observação das threads
		state = 3
	end

	--Maquina de estados: Estado 3 // Observa as threads
	if state == 3 then
		--Verifica se há mensagens novas, e se tiver, adiciona-as a pilha de mensagens.
		if channel:peek() ~= nil then
			table.insert(messages, "Thread "..(returns+1).." : "..channel:pop())
			returns = returns + 1
			--Efeito visual na bolinha
			ball8.y = ball8.y - 12
			pop:play()

		end

		--Troca de estado caso todas as threads tenham respondido a pergunta
		if returns == threadCount then
			returns = 0
			state = 4
			table.insert(messages, "Finalizado! Pergunta: '"..textField:getText().."'")
		end

		ball8.y = lerp(ball8.y, 40, 0.002)
		vaiB:setVisible(false)
	end

	--Maquina de estados: Estado 4 // Fim
	if state == 4 then
		ball8.y = lerp(ball8.y, 40, 0.007)
		vaiB:setVisible(true)
	end
end

function love.draw()
	--Desenha a UI e a bola na tela.
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(ball8.image, ball8.x, ball8.y)
	gooi.draw()

	if state ~= 1 then
		printOnScreen()
	end
	if alphaUi ~= 255 then
		love.graphics.setFont(font2)
		love.graphics.setColor(255, 255, 255, 255-alphaUi)
		love.graphics.print("8Thread", 180, 350)
	end
end

function love.mousepressed(x, y, button)  gooi.pressed() end
function love.mousereleased(x, y, button) gooi.released() end
function love.textinput(text) gooi.textinput(text) end

function lerp(a, b, rate) --EMPLOYEE OF THE MONTH
	local result = (1-rate)*a + rate*b
	return result
end

function printOnScreen()
	love.graphics.setFont(font)
	if #messages > 11 then
		while #messages ~= 11 do
			table.remove(messages, 1)
		end
	end

	for i = 1, #messages do
		love.graphics.print(messages[i], 25, 210+(20*i))
	end
end

function love.threaderror(thread, errorstr)
  print("Thread error!\n"..errorstr)
end
